!Cmnt -----------------------------------------------------------------
!Cmnt -----------------------------------------------------------------
!Cmnt 
!Cmnt ------------------  THIS IS SIZEMPSFFAV16.FOR  ------------------ 
!Cmnt ---------  A DIMENSIONING PROGRAM FOR  MPSFFAV1-16.FOR  ---------
!Cmnt 
!Cmnt If you need to run the simulator for dimensions larger than those 
!Cmnt specified here, follow the definitions below and modify the values
!Cmnt of certain parameters as needed. You may only change the 
!Cmnt parameters that have numerical values. You must not assign a value
!Cmnt to any parameter that has a formula to define it. Save changes to   
!Cmnt the dimensioning program (SIZEMPSFFAV1-16.FOR), recompile the main  
!Cmnt program (MPSFFAV1-16.FOR), and rebuild the executable file
!Cmnt MPSFFAV1-16.EXE. 
!Cmnt 
!Cmnt -----------------------------------------------------------------
!Cmnt 
!Cmnt =================================================================
!Cmnt                                                                 |
!Cmnt                   =========================                     |
!Cmnt                   DIMENSIONING OF THE MODEL                     |
!Cmnt                   =========================                     |
!Cmnt                                                                 |
!Cmnt     NOTE THAT ALL SYMBOLS ARE IN CAPITAL LETTERS.               |
!Cmnt SYMBOL                 EXPLANATION                 MAX. MIN. EG.|
!Cmnt ------                 -----------                 ---- ---- ---|
!Cmnt  I9A   NO. OF BLOCKS IN THE X-DIRECTION .........  -     1    10|
!Cmnt  I9B   NO. OF BLOCKS IN THE Y-DIRECTION .........  -     1    10|
!Cmnt  I9C   NO. OF BLOCKS IN THE Z-DIRECTION .........  -     1     3|
!Cmnt  I9D   TOTAL NO. OF BLOCKS = I9A*I9B*I9C ........  -     1   300|
!Cmnt  I9E   TOTAL NO. OF ACTIVE BLOCKS IN THE RESERVOIR I9D   1   165|
!Cmnt  I8E   I8E = I9E FOR S.S. METHOD;  I8E = 1 ELSE .  I9E   1   165|
!Cmnt  I7E   I7E = I9E FOR ITER. METHOD; I7E = 1 ELSE .  I9E   1   165|
!Cmnt  I9F   NO. OF RESERVOIR ROCK REGIONS ............  I9E   1     1|
!Cmnt  I9G   NO. OF MAX. ENTRIES IN W-O KR TABLES .....  -     2     2|
!Cmnt  I9H   NO. OF MAX. ENTRIES IN G-O KR TABLES .....  -     2    14|
!Cmnt  I9I   NO. OF MAX. ENTRIES IN PVT TABLES ........  -     2    11|
!Cmnt  I9J   NO. OF ENTRIES IN POL. CONC. VS. VISCOSITY  -     2     2|
!Cmnt  I9K   NO. OF ENTRIES IN ADS . VS. RESIST. TABLE   -     2     2|
!Cmnt  I9L   NO. OF FLUID PVT REGIONS IN THE RESERVOIR   I9D   1     1|
!Cmnt  I9M   MAXIMUM NUMBER OF WELLS ................... I9E   1   165|
!Cmnt  I9N   NO. OF ENTRIES IN THE EQUI-SPACED TABLES .. -     2   500|
!Cmnt  I1O   I1O = MIN(I9A,I9B,I9C) .................... -     1     3|
!Cmnt  I3O   I3O = MAX(I9A,I9B,I9C) .................... -     1    10|
!Cmnt  I2O   I2O = I9A+I9B+I9C-I1O-I3O ................. -     1    10|
!Cmnt  I9Q   NO. OF TIMES WELLS CHANGE CONDITIONS .....  -     1     1|
!Cmnt  I9R   NO. OF EQUATIONS PER BLOCK ...............  4     1     3|
!Cmnt  I8R   I8R = 4 FOR S.S. METHOD;  I8R = 1 ELSE ...  4     1   165|
!Cmnt  I7R   I7R = 4 FOR ITER. METHOD; I7R = 1 ELSE ...  4     1   165|
!Cmnt  I9S   TOTAL NO. OF UNKOWNS PLUS ONE = 1+R*E ... 1+4*I9E 2   496|
!Cmnt  I9T   I9T = I9Q*I9M ............................  -     1     2|
!Cmnt  I9W   I9W = K7 (DUMMY RUN OR [D4=1+E/2, NAT.=E])  -     1    80|
!Cmnt  I9X   I9X=I9W FOR D4 ORDER; I9X=7 FOR NAT ORDER; I9X=1 FOR ITER|
!Cmnt  I8X   I8X = I9X ................................. -     1    80|
!Cmnt  I9Y   I9Y=NMAX (DUMMY RUN FOR S.S.); I9Y=1 (ITER.)-     1 17712|
!Cmnt  I9A1  PARAMETER FOR PRINTTING ARRAYS IN OUTPUT FILE            |
!Cmnt  I9A2  PARAMETER FOR PRINTTING ARRAYS IN OUTPUT FILE            |
!Cmnt  I9B1  PARAMETER FOR PRINTTING ARRAYS IN OUTPUT FILE            |
!Cmnt  I9C1  PARAMETER FOR PRINTTING ARRAYS IN OUTPUT FILE            |
!Cmnt  I991  PARAMETER FOR PRINTTING ARRAYS IN OUTPUT FILE            |
!Cmnt  I3E   I3E = MAX(NTMAX-1-NORTH) PARAMETER IN ORTHOMIN   40      |
!Cmnt -----------------------------------------------------------------
!Cmnt -----------------------------------------------------------------
      IMPLICIT REAL(8) (A-H,O-Z)
      IMPLICIT INTEGER(4) (I-N)
      CHARACTER (LEN=80) LABEL,TITLE,AKNLDG,MESAG1,S11T37,ERRMSG,
     &             INP1,INP2,OUTA,OUTD,OUTE,OUTF,OUTG,OUTH,
     &             OUTI,OUTJ,OUTL,DASHI,DASHF,DASHE,LAYERI,SOLMTD,
     &             UNITO,UNITI,UNITB,UNITC,UNITD,UNITE,XUNITS
      INTEGER, PARAMETER :: I9A=40
      INTEGER, PARAMETER :: I9B=40
      INTEGER, PARAMETER :: I9C=40
      INTEGER, PARAMETER :: I9D=I9A*I9B*I9C
      INTEGER, PARAMETER :: I9E=4000
!Cmnt CCCCCCCC START CCCCCCC
      INTEGER, PARAMETER :: I8E=I9E
!Calt      INTEGER, PARAMETER :: I8E=1
!Cmnt CCCCCCCC  END  CCCCCCC
      INTEGER, PARAMETER :: I7E=I9E
      INTEGER, PARAMETER :: I9F=30
      INTEGER, PARAMETER :: I9G=30
      INTEGER, PARAMETER :: I9H=30
      INTEGER, PARAMETER :: I9I=30
      INTEGER, PARAMETER :: I9J=30
      INTEGER, PARAMETER :: I9K=30
      INTEGER, PARAMETER :: I9L=30
      INTEGER, PARAMETER :: I9M=200
      INTEGER, PARAMETER :: I9N=500
      INTEGER, PARAMETER :: I1O=MIN(I9A,I9B,I9C)
      INTEGER, PARAMETER :: I3O=MAX(I9A,I9B,I9C)
      INTEGER, PARAMETER :: I2O=I9A+I9B+I9C-I1O-I3O
      INTEGER, PARAMETER :: I9Q=100
      INTEGER, PARAMETER :: I9R=4
!Cmnt CCCCCC START CCCCCC
      INTEGER, PARAMETER :: I8R=I9R
!Calt      INTEGER, PARAMETER :: I8R=1
!Cmnt CCCCCC  END  CCCCCC
      INTEGER, PARAMETER :: I7R=I9R
      INTEGER, PARAMETER :: I9S=1+I9R*I9E
      INTEGER, PARAMETER :: I9T=I9Q*I9M
      INTEGER, PARAMETER :: I9W=I9E
      INTEGER, PARAMETER :: I9X=I9W
!Cmnt CCCCCC  START CCCCCC
      INTEGER, PARAMETER :: I8X=I9X
      INTEGER, PARAMETER :: I9Y=2000000
!Calt     INTEGER, PARAMETER :: I8X=1
!Calt     INTEGER, PARAMETER :: I9Y=1
!Cmnt CCCCCCC  END  CCCCC
      INTEGER, PARAMETER :: I9A1=1+I9A/10
      INTEGER, PARAMETER :: I9A2=1+I9A/20
      INTEGER, PARAMETER :: I9B1=1+I9B/10
      INTEGER, PARAMETER :: I9C1=1+I9C/10
      INTEGER, PARAMETER :: IEE1=1+9/10
      INTEGER, PARAMETER :: I3E=40
!Cmnt ------------------------------------------------------------------
!Cmnt ------------------------------------------------------------------
      COMMON/COMB01 /DASHI(10000),DASHF(10000),DASHE(10000),LAYERI(100)
      COMMON/COMB02 /SOLMTD(4),UNITO(3),UNITI(3),UNITB(3),UNITC(3),
     &               XUNITS(3),UNITD(3),UNITE(3)
      COMMON/COMB03 /DUMVC(10)
      COMMON/COMB03A/KKA(I9A2),KKB(I9A2),IIA(I9A1),IIB(I9A1),
     &               IJA(I9B1),IJB(I9B1),IKA(I9C1),IKB(I9C1),
     &               IPA(IEE1),IPB(IEE1),IDUMVC(10)
      COMMON/COMB03B/NHEX,NSEGX,NSEGY,NSEGZ,NSEGP,NXTRA,NYTRA,
     &               NZTRA,NPTRA,MHEX,MSEGX,NOPR,NOPH
      COMMON/COMB03C/IVEC(I9E)
      COMMON/COMB04 /B8(14),B7(8),B1(7),B2(7),B3(7),B5(6),B6(6),B4(3),
     &               PYE
      COMMON/COMB05 /BBLKCO(I9E),QINFA(I9E),CQINFA(I9E),
     &                            AQP0(I9E),BBLKWT(I9E)
      COMMON/COMB05A/AWINFA(I9E,4),BWINFA(I9E,4)
      COMMON/COMB06 /AQFH,AQKH,AQRW,AQRE,AQANGL,AQCWE,AQMUW,AQRD,AQTDCO
      COMMON/COMB07 /NFACTV(I9E),IDAQFR,NFACT
      COMMON/COMB08 /QOINFA(I9E),QWINFA(I9E),QPINFA(I9E),
     &               DONFSO(I9E),DWNFSO(I9E),DPNFSO(I9E),
     &               DONFSW(I9E),DWNFSW(I9E),DPNFSW(I9E),
     &               DONFSP(I9E),DWNFSP(I9E),DPNFSP(I9E),
     &               DONFPO(I9E),DWNFPO(I9E),DPNFPO(I9E),
     &               DGNFSO(I9E),DGNFSW(I9E),DGNFSP(I9E),
     &               DGNFPO(I9E),QGINFA(I9E)
      COMMON/COMB09 /RMOESO(I9E),RMOESW(I9E),RMOESP(I9E),
     &               RMWESO(I9E),RMWESW(I9E),RMWESP(I9E),
     &               RMPESO(I9E),RMPESW(I9E),RMPESP(I9E),
     &               RMGESO(I9E),RMGESW(I9E),RMGESP(I9E),
     &               RMOEPO(I9E),RMWEPO(I9E),RMPEPO(I9E),
     &               RMGEPO(I9E),   RMO(I9E),   RMW(I9E),
     &                  RMP(I9E),   RMG(I9E)
      COMMON/COMB10 /SMOESO(I9E),SMOESW(I9E),SMOESP(I9E),
     &               SMWESO(I9E),SMWESW(I9E),SMWESP(I9E),
     &               SMPESO(I9E),SMPESW(I9E),SMPESP(I9E),
     &               SMGESO(I9E),SMGESW(I9E),SMGESP(I9E),
     &               SMOEPO(I9E),SMWEPO(I9E),SMPEPO(I9E),
     &               SMGEPO(I9E),   SMO(I9E),   SMW(I9E),
     &                  SMP(I9E),   SMG(I9E)
      COMMON/COMB11 /IPRNTV(12),INPUT1,IOUTP1,ISCREN
      COMMON/COMB12 /LFKITR(6,I7E),LBKITR(6,I7E)
      COMMON/COMB13 /IJXV(I9A,I9B,I9C),IMXJK(I9B,I9C)
      COMMON/COMB14 /JV(I9B,I9C),JMXK(I9C),KV(I9C),NZF
      COMMON/COMB15 /DL1(I7R,I7R,I7E),  DD9(I7R,I7R)  
      COMMON/COMB15A/DU1(I7R,I7R,I7E),  DMM(I7R,I7R,I7E)
      COMMON/COMB15B/CS3(I7R,I7R,I7E),  DU2(I7R,I7R,I7E)
      COMMON/COMB15C/CS2(I7R,I7R,I7E),  SC4(I7R,I7R,I7E)
      COMMON/COMB15D/SC5(I7R,I7R,I7E),  DL3(I7R,I7R,I7E)
      COMMON/COMB15E/DU3(I7R,I7R,I7E),  DL2(I7R,I7R,I7E)
      COMMON/COMB15F/DMI(I7R,I7R,I7E),DMIU1(I7R,I7R,I7E)
      COMMON/COMB16 /BB1(I7R,I7R,I7E),DDI(I7R,I7R)
      COMMON/COMB16A/BB2(I7R,I7R,I7E),BB3(I7R,I7R,I7E)
      COMMON/COMB16B/BB4(I7R,I7R,I7E),CC4(I7R,I7R,I7E)
      COMMON/COMB16C/BB5(I7R,I7R,I7E),BB6(I7R,I7R,I7E)
      COMMON/COMB16D/CC1(I7R,I7R,I7E),AA5(I7R,I7R,I7E)
      COMMON/COMB16E/AA6(I7R,I7R,I7E),CC2(I7R,I7R,I7E)
      COMMON/COMB16F/CC3(I7R,I7R,I7E), DD(I7R,I7R,I7E)
      COMMON/COMB17 /CMUOF(I9L),DENOSC(I9L),  COF(I9L),
     &               GAMAW(I9L),DENWSC(I9L),  API(I9L),
     &               DWSCF(I9L),DENGSC(I9L),GAMAG(I9L)
      COMMON/COMB17A/ PTAP(I9I,I9L),RSTAP(I9I,I9L),
     &               BWTAP(I9I,I9L),BOTAP(I9I,I9L),
     &               BGTAP(I9I,I9L),UWTAP(I9I,I9L),
     &               UOTAP(I9I,I9L),UGTAP(I9I,I9L)
      COMMON/COMB17B/LFRGNS(I9E),MUMPVT(I9L)
      COMMON/COMB17C/IFRGNS
      COMMON/COMB18 /NUMPVT,NPPV
      COMMON/COMB18A/ PTAB(I9I),RSTAB(I9I),
     &               BWTAB(I9I),BOTAB(I9I),BGTAB(I9I),
     &               UWTAB(I9I),UOTAB(I9I),UGTAB(I9I) 
      COMMON/COMB18B/CPLTAB(I9J),UPLTAB(I9J)
      COMMON/COMB19 /CONP1,CONP9,DCONPT,ACRP1,ACRP9,DACRPT
      COMMON/COMB19A/EMP(3,I9N),ERF(3,I9N),ERRF(3,I9N)
      COMMON/COMB20 /PPVT1(I9L),PPVT9(I9L),DPPVTT(I9L),
     &               RSBB1(I9L),RSBB9(I9L),DRSBBT(I9L)
      COMMON/COMB20A/EBO(3,I9N,I9L),EMO(3,I9N,I9L)
      COMMON/COMB20B/EBR(3,I9N,I9L),EMR(3,I9N,I9L)
      COMMON/COMB20C/EBW(3,I9N,I9L),EMW(3,I9N,I9L)
      COMMON/COMB20D/EBG(3,I9N,I9L),EMG(3,I9N,I9L)
      COMMON/COMB20E/ERS(3,I9N,I9L),EPR(3,I9N,I9L)
      COMMON/COMB21 /SATW1(I9F),SATW9(I9F),DSATWT(I9F),
     &               SATL1(I9F),SATL9(I9F),DSATLT(I9F)
      COMMON/COMB21A/ EKRW(3,I9N,I9F), EKOW(3,I9N,I9F)
      COMMON/COMB21B/ EKRG(3,I9N,I9F), EKOG(3,I9N,I9F)
      COMMON/COMB21C/ EPCW(3,I9N,I9F), EPCG(3,I9N,I9F)
      COMMON/COMB22 / ARRAY(I9D)
      COMMON/COMB22A/ AGRAY(I9D)
      COMMON/COMB22B/ARRAY2(I9D)
      COMMON/COMB22C/ARRAY3(I9D)
      COMMON/COMB22D/ IRRAY(I9D)
      COMMON/COMB22E/IRRAY2(I9D)
      COMMON/COMB22F/IRRAY3(I9D)
      COMMON/COMB23 /NX,NY,NZ,NY1,NZ1,NGP,NGPACT,NNTBL,NTBL,IQUAD,
     &               ISWSIM,NORTH,NTMAX,NSTPNC,MSTPCN,ISTPCN
      COMMON/COMB23A/JACTV(I9D),KACTV(I9E)
      COMMON/COMB24 /NIACT,NPACT,NCACT
      COMMON/COMB24A/NIACTV(I9E),NPACTV(I9E),NCACTV(I9E)
      COMMON/COMB25 /QRWPO(I9E),QROPO(I9E),QRGPO(I9E),
     &               QRWSW(I9E),QROSW(I9E),QRGSW(I9E),
     &               QRWSO(I9E),QROSO(I9E),QRGSO(I9E),
     &               QRWSP(I9E),QROSP(I9E),QRGSP(I9E),
     &               QRPPO(I9E),QRPSW(I9E),QRPSO(I9E),
     &               QRPSP(I9E) 
      COMMON/COMB26 /FLOWW(I9E),FLOWO(I9E),FLOWP(I9E),
     &               FLOWG(I9E)
      COMMON/COMB27 /XSORW(I9F),XSWC(I9F),XRKOCW(I9F),
     &               XSORG(I9F),XSGC(I9F)
      COMMON/COMB27A/XSWT(I9G,I9F), XRKOW(I9G,I9F),
     &               XRKW(I9G,I9F), XPCOW(I9G,I9F),
     &                             XPCOWI(I9G,I9F)
      COMMON/COMB27D/XSLT(I9H,I9F), XRKOG(I9H,I9F),
     &               XRKG(I9H,I9F), XPCOG(I9H,I9F),
     &                             XPCOGI(I9H,I9F)
      COMMON/COMB27B/MUMSWT(I9F),MUMSLT(I9F),LRRGNS(I9E)
      COMMON/COMB27C/IRRGNS
      COMMON/COMB28 /NCOR(3),ICOR(3),LOK(3),NUSLVR
      COMMON/COMB29 /MVBAND(I9S),NNN,MMM,MATBAK
      COMMON/COMB30 /DTMAX,DTMIN,USEP,DELPO,DELRS,DELSAT,DLMTRS,ALFARS,
     &               ALFAPO
      COMMON/COMB30A/DLIMIT(4),ALPHA(4)
      COMMON/COMB31 /DHTSTP(4,I9E),HTSTEP(I9E)
      COMMON/COMB32 /GMAT(I9R,I9R),XDOTC(I9R),GRHS(I9R)
      COMMON/COMB33 /XDOTB(I9R,I9E)
      COMMON/COMB34 /AFORXC(4,4,I9E),FFORXC(4,I9E)
      COMMON/COMB35 /X(I9S),R(I9S)
      COMMON/COMB35A/VBB(4,4,7,I9E)
      COMMON/COMB36 /POOLD(I9E),PONEW(I9E),RSOLD(I9E),
     &               SWOLD(I9E),SOOLD(I9E),SGOLD(I9E),
     &               SWNEW(I9E),SONEW(I9E),SGNEW(I9E),
     &               BWOLD(I9E),BOOLD(I9E),BGOLD(I9E),
     &               BWNEW(I9E),BONEW(I9E),BGNEW(I9E)
      COMMON/COMB36A/PBUBL(I9E), RS8B(I9E), FVFO(I9E),
     &               UWOLD(I9E),UPOLD(I9E),UWEFF(I9E),
     &               FYOLD(I9E),FYNEW(I9E),FYREF(I9E),
     &               RSNEW(I9E),SPOLD(I9E),SPNEW(I9E),
     &               SANEW(I9E),UPEFF(I9E)
      COMMON/COMB37 /WAT9IP(I9E),OIL9IP(I9E),GAS9IP(I9E),
     &                OILIP(I9E),POL9IP(I9E),POLCIP(I9E),
     &               ROCMAS(I9E)
      COMMON/COMB38 /OBPORE,WBPORE,GBPORE,PBPORE,OVBSTC,WVBSTC,
     &               GVBSTC,PVBSTC
      COMMON/COMB39 / IXGAS(I9E), IOLDG(I9E),IWC(I9E),
     &               IWCSPC(I9E),IDWELL(I9E)
      COMMON/COMB39A/ INDX(I9D)
      COMMON/COMB40 /DELXV(I9D)
      COMMON/COMB40A/DELYV(I9D)
      COMMON/COMB40B/DELZGV(I9D)
      COMMON/COMB40D/DELZNV(I9D)
      COMMON/COMB40C/   VBV(I9E), THIKV(I9E)
      COMMON/COMB41 /PERMXV(I9E),PERMYV(I9E),PERMZV(I9E)
      COMMON/COMB41A/ HPHIV(I9E),  HKHV(I9E),PHIKHV(I9E)
      COMMON/COMB42 / AKV(7,I9E)
      COMMON/COMB43 /EEP,EES,EER,EPSI
      COMMON/COMB44 /SIMTME,TOTIME,TIMUSE,DTIME,DTOLD,TMSTOP
      COMMON/COMB45 /ITERK,NORTMN,NTITER,ISTEP,NPASS,ITMAX,IRSTRT,
     &               IPRDAT 
      COMMON/COMB46 /CR,CO,CMUO,PREF,OMIX,DENR,TMOIL
      COMMON/COMB47 /WORMKS,GORMKS,QOECON
      COMMON/COMB47A/WQSPC(I9E),POLCIN(I9E),POLCPD(I9E),
     &               PSAND(I9E),PSFACE(I9E),    WI(I9E)
      COMMON/COMB48 /CP9WAT,CP9OIL,CP9GAS,CP9POL,T9WAT,T9OIL,T9GAS,
     &               T9POL,CP9PPC,T9POLC
      COMMON/COMB49 /ISW,ISO,IPO,ISP,IWE,IOE,IGE,IPE,NQW,NQO,NQG,NQP
      COMMON/COMB50 /TOTIOL,TOTIWT,TOTIGS,TOTIPM,TOTPOL,TOTPWT,
     &               TOTPGS,TOTPPM,TOTIPC,TOTPPC,
     &               TOTINF,COINFA,CWINFA,CPINFA,CGINFA,CPCNFA
      COMMON/COMB51 /JSKJ(7,I9E),JMAX(I9E) 
      COMMON/COMB51A/IIKJ(7,I9E),IIKJNO(7,I9E)
      COMMON/COMB51B/   IJKA(3,I9D),IJK(3,I9E)
      COMMON/COMB51C/LOCATE(7,I9D)
      COMMON/COMB52 /INOUTP,IPRINT,IFTSDBG,ILTSDBG,NFRWEL,NFRARY,
     &               NCHEQ1,NCHEQ2,NWRITE,NFRRES,NCHEQ0,NCHEK
      COMMON/COMB53 /NNMAX,NGMNX1,NXP22
      COMMON/COMB54 /LMIN,LMAX,LSTEP,ICNTR,ND123,NUMEQN,NUMUKN,MOD,
     &               NXYZORD,NUMDUM
      COMMON/COMB55 /EPS2,EPSGAS,CF0,CF1,CF2,CF3,CF4,CF5,CF6,CF7,CF8,
     &               CF9,CF10,CF11,ALFAC,BETAC,GAMAC,PSC,MUNITI,MUNITO
      COMMON/COMB56 /DEEP1,SINX,SINY
      COMMON/COMB56A/ ZELV(I9E),ZELVC(I9E),  ZELD(I9E)
      COMMON/COMB57 /CINJW(I9E),CINJO(I9E),CPCRDP(I9E),
     &               CINJG(I9E),CPRDO(I9E),CINJPC(I9E),
     &               CINJP(I9E),CPRDW(I9E),
     &               CPRDG(I9E),CPRDP(I9E)
      COMMON/COMB58 /NOWSTP,LCOUNT,JCOUNT
      COMMON/COMB58A/ALLSIM(I9Q),TIMEST(I9Q),WORMAX(I9Q),
     &               GORMAX(I9Q),QOEKON(I9Q),NRITEN(I9Q),
     &               NALLWL(I9Q)
      COMMON/COMB58B/TEMPWL(5,I9T)
      COMMON/COMB58C/NLOCTP(4,I9T)
      COMMON/COMB59 /CPPPM(I9E),CONCPB(I9E),CONCPI(I9E),
     &               CAMAX(I9E),CRPNEW(I9E),CPPPMI(I9E),
     &                 CRP(I9E)
      COMMON/COMB59A/CTPPM(I9E),CONCTB(I9E),CONCTI(I9E),
     &                                      CTPPMI(I9E)
      COMMON/COMB60 /VBMOD(I9E),VZMOD(I9E),VFMOD(I9E),
     &               TXMOD(I9E),TYMOD(I9E),TZMOD(I9E)
      COMMON/COMB61 /NUMADS
      COMMON/COMB61A/ADSTAB(I9K),RFTAB(I9K),RRFTAB(I9K)
      COMMON/COMB62 /RF(I9E),RRF(I9E)
      COMMON/COMB63 /  POTA(I9E),  POTO(I9E),  POTG(I9E),
     &               DPAEPO(I9E),DPAESW(I9E),DPAESO(I9E),
     &               DPOEPO(I9E),DPOESW(I9E),DPOESO(I9E),
     &               DPGEPO(I9E),DPGESW(I9E),DPGESO(I9E),
     &               DPAESP(I9E),DPOESP(I9E),DPGESP(I9E)
      COMMON/COMB63A/GRAVA(7,I9E),GRAVO(7,I9E),GRAVG(7,I9E)
      COMMON/COMB64 /FLOWIO,FLOWIW,FLOWIG,FLOWIP,FLWIPC,FLOWPO,FLOWPW,
     &               FLOWPG,FLOWPP,FLWPPC,SOMIN1,SWMIN1,SGMIN1,SPMIN1,
     &               SAMIN1,SOMAX1,SWMAX1,SGMAX1,SPMAX1,SAMAX1,OILMBC,
     &               OILACT,WATMBC,WATACT,GASMBC,GASACT,POLMBC,POLACT,
     &               POLCBC,POLCAT,OILMBI,DACO,WATMBI,DACW,GASMBI,DACG,
     &               POLMBI,DACP,POLCBI,DACPC,AQSMBI,AQSMBC,FLAINF,
     &               FLOINF,FLWINF,FLPINF,FLGINF,FLPCNF,LOMAX,LAMAX,
     &               LWMAX,LPMAX,LGMAX,LOMIN,LAMIN,LWMIN,LPMIN,LGMIN
      COMMON/COMB65 /ECSR(I9E)
      COMMON/COMB66 / TWPO(7,I9E),TWPOE(7,I9E), TOPO(7,I9E)
      COMMON/COMB66A/TOPOE(7,I9E), TGPO(7,I9E),TGPOE(7,I9E)
      COMMON/COMB66B/ TPPO(7,I9E),TPPOE(7,I9E),TWSWE(7,I9E)
      COMMON/COMB66C/TOSWE(7,I9E),TGSWE(7,I9E),TPSWE(7,I9E)
      COMMON/COMB66D/TWSOE(7,I9E),TOSOE(7,I9E),TGSOE(7,I9E)
      COMMON/COMB66E/TPSOE(7,I9E),TWSPE(7,I9E),TOSPE(7,I9E)
      COMMON/COMB66F/TGSPE(7,I9E),TPSPE(7,I9E)
      COMMON/COMB67 /DWPO(I9E),DOPO(I9E),DGPO(I9E),
     &               DWSW(I9E),DOSW(I9E),DGSW(I9E),
     &               DWSO(I9E),DOSO(I9E),DGSO(I9E),
     &               DWSP(I9E),DOSP(I9E),DGSP(I9E),
     &               DPPO(I9E),DPSW(I9E),DPSO(I9E),
     &               DPSP(I9E)
      COMMON/COMB68 /RSOESO(I9E),RSOEPO(I9E),BW9EPO(I9E),
     &               BO9EPO(I9E),BO9ESO(I9E),BG9EPO(I9E)
      COMMON/COMB69 /TRANS3,TRANS5,TRANS7,INIOPT,ICASE
      COMMON/COMB70 /LIJK(I9A,I9B,I9C)
      COMMON/COMB70A/MIJK(I1O,I2O,I3O)
      COMMON/COMB71 /DUMVBB(I8R,I8R,I8X)
      COMMON/COMB71A/KORDR1(I9E)
      COMMON/COMB71B/LORDR2(I9W),K5,K7
      COMMON/COMB72 /LOCAT2(I8X)
      COMMON/COMB73 /ILEFT(I9E),IRIGT(I9E)
      COMMON/COMB73A/MLB(I9S),MRB(I9S)
      COMMON/COMB74 /FLOPO(I9E),FLOPA(I9E),FLOPG(I9E),
     &                IWCP(I9E), IWC1(I9E), IWC2(I9E),
     &              IPFORC(I9E)
      COMMON/COMB75 / RHS(4,I9E)
      COMMON/COMB76 /RHS0(4,I9E)
      COMMON/COMB77 /TIMEX,PAVG,RECOX,PVIP,PVIA,PVIG,PVI,QOPRDX,
     &               QAPRDX,QGPRDX,CUMPRO,CUMPRA,CUMPRG,AORX,GORX
      COMMON/COMB78 /DDXX(I9A)
      COMMON/COMB78A/DDYY(I9B)
      COMMON/COMB78B/DDZZ(I9C)
      COMMON/COMB79 /IXMAX(I9E)
      COMMON/COMB80 /VERTVL(I9R,I9R,I9E)
      COMMON/COMB81 /CPOUT(I9E),PPMOUT(I9E)
      COMMON/COMB81A/CTOUT(I9E)
      COMMON/COMB82 /SUMSAT(I9E)
      COMMON/COMB83 /IFKNS,IFADS
      COMMON/COMB83A/IFRKW(I9F),IFRKG(I9F)
      COMMON/COMB83B/IFPVT(I9L)
      COMMON/COMB84 / NUMSWT,NUMSLT
      COMMON/COMB84A/SWT(I9G),RKW(I9G),RKOW(I9G),PCOW(I9G),
     &               PCOWI(I9G)
      COMMON/COMB84B/SLT(I9H),RKG(I9H),RKOG(I9H),PCOG(I9H),
     &               PCOGI(I9G)
      COMMON/COMB85 /MESAG1(50),S11T37(50)
      COMMON/COMB85A/ERRMSG(10,50)
      COMMON/COMB86 /DATMIN(50),DATMAX(50),MAXDAT(50),MINDAT(50)
      COMMON/COMB87 /XX(I7R,I7E),VVX(I7R,I7E),YV9(I7R,I7E),
     &                Q(I7R,I7E), QM(I7R,I7E), XM(I7R,I7E)
      COMMON/COMB87A/ QSAV(I7R,I7E,I3E)
      COMMON/COMB87B/QMSAV(I7R,I7E,I3E)
      COMMON/COMB88 /AA(I9Y)
      COMMON/COMB89 /NCOR1,NCOR2,NCOR3,ICOR1,ICOR2,ICOR3,
     &               LOKA1,LOKA2,LOKA3,LOKA4,LOKA5,LOKA6,LOKA7
      COMMON/COMB90 /RADW,RADE,ARRAY0(I9E)
!Cmnt -----------------------------------------------------------------
!Cmnt -----------------------------------------------------------------
